local addon = MissionMinder;
local options = addon.options;
local DEBUG = MissionMinder.debug;

local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");

function addon.init()
	addon.planner.initialize();
	addon.listview.initialize();
	addon.skipfights.initialize();
	addon.quickloot.initialize();
	addon.autoclose.initialize();
	addon.autoloot.initialize();

	addon.followers.initialize();
end


local frame = CreateFrame("Frame");
addon.frame = frame;

local events = {};
addon.events = events;

function events:RegisterEvent(event, func)
	if ( self[event] ) then -- event already exists, post-hook
		local previous = self[event];
		self[event] = function(...)
			previous(...);
			func(...);
		end;
	else
		self[event] = func
	end

	addon.frame:RegisterEvent(event);
end

function frame:OnEvent(event, ...)
	--[===[@alpha@
	print("|cffcccccc[DEBUG]", event, ...)
	--@end-alpha@]===]
	if ( events[event] ) then
		events[event](event, ...);
	end
end
frame:SetScript("OnEvent", frame.OnEvent);

events:RegisterEvent("ADDON_LOADED", function(event, addonName)
	if addonName == addon.name then
		addon:init();
		frame:UnregisterEvent("ADDON_LOADED");
		DEBUG("%s %s loaded", addon.name, addon.version);
	end
end);